module.exports = {
  'env': {
    'browser': true,
    'es6': true
  },
  'extends': [
    'eslint:recommended',
    'plugin:@typescript-eslint/eslint-recommended'
  ],
  'globals': {
    'Atomics': 'readonly',
    'SharedArrayBuffer': 'readonly'
  },
  'parser': '@typescript-eslint/parser',
  'parserOptions': {
    'ecmaVersion': 2021,
    'sourceType': 'module'
  },
  'plugins': [
    '@typescript-eslint'
  ],
  'rules': {
    'indent': [
      'error',
      2,
      { 'SwitchCase': 1 }
    ],
    'linebreak-style': [
      'error',
      'unix'
    ],
    'quotes': [
      'error',
      'single',
      { 'allowTemplateLiterals': true }
    ],
    'semi': [
      'error',
      'never'
    ],
    'eol-last': ['error', 'always'],
    'eqeqeq': ['error', 'always'],
    'spaced-comment': ['error', 'always', { 'markers': ['/'] }],
    'block-spacing': ['error', 'always'],
    'no-whitespace-before-property': ['error'],
    'no-trailing-spaces': ['error'],
    'space-in-parens': ['error', 'always'],
    'object-curly-spacing': ['error', 'always'],
    'no-unused-vars': ['off'],
    'brace-style': 'off',
    '@typescript-eslint/type-annotation-spacing': ['error', {
      before: false,
      after: true,
      overrides: { arrow: { before: true, after: true } }
    }],
    '@typescript-eslint/brace-style': ['error'],
    '@typescript-eslint/explicit-function-return-type': ['error'],
  'max-len': ['warn', { 'code': 120 }],
    'no-multi-spaces': ['warn'],
    'space-infix-ops': ['warn'],
    'key-spacing': ['warn'],
    'comma-spacing': ['warn'],
    'arrow-spacing': ['warn'],
    'padding-line-between-statements': [
      'warn',
      { 'blankLine': 'always', 'prev': 'function', 'next': 'function' },
      { 'blankLine': 'always', 'prev': 'multiline-block-like', 'next': 'multiline-block-like' },
      { 'blankLine': 'always', 'prev': 'multiline-expression', 'next': 'multiline-block-like' },
      { 'blankLine': 'always', 'prev': 'multiline-block-like', 'next': 'multiline-expression' },
      { 'blankLine': 'always', 'prev': 'multiline-expression', 'next': 'multiline-expression' },
      { 'blankLine': 'always', 'prev': 'import', 'next': 'expression' },
  ],
  'no-multiple-empty-lines': ['warn', {'max': 1}]
  },
  overrides: [
    {
      'files': [ 'spec/**/*.spec.ts' ],
      'rules': {
        'max-len': ['off']
      }
    }
  ],
  ignorePatterns: [
    '*.js'
  ]
}
